//$Header: /home/cvsroot/a3pro/include/debug.h,v 1.1.1.1 2003/07/01 08:57:56 dan Exp $
//Draft by Dan 2003-3-20
#ifndef _DEBUG_H_
#define _DEBUG_H_


#include <stdarg.h>
#include <stdio.h>

//#define _DEBUG_
//#undef _DEBUG_

#define DEBUG_ASIC 1
#define DEBUG_SPICALL 2
#define DEBUG_SCANOBJ 4
#define DEBUG_PANEL 8
#define DEBUG_SANE 16
#define DEBUG_LIBUSB 32


#define DEBUG_LEVEL   0//	(DEBUG_SPICALL)
//	(DEBUG_ASIC  | DEBUG_SPICALL | DEBUG_SCANOBJ | DEBUG_PANEL | DEBUG_SANE)


#ifdef _DEBUG_

#define XDBG(level,fmt,msg...) PDebugInfo(level,fmt, ##msg)	

#else

#define XDBG(level,fmt,msg...)

#endif


static void PDebugInfo(int level, const char* fmt,...)
{
	va_list ap; 
	
	if (level == 0)
		return;
	
	va_start(ap,fmt);

	if (0 == (level & DEBUG_LEVEL)) 
	{	
		va_end(ap);
		return;
	}

	if (0 != (level & DEBUG_ASIC))
	{
		fprintf(stderr,"[ASIC]: ");
		vfprintf(stderr,fmt,ap);
		fprintf(stderr,"\n");
	}

	if (0 != (level & DEBUG_SPICALL))
	{
		fprintf(stderr,"[SPICALL]: ");
		vfprintf(stderr,fmt,ap);
		fprintf(stderr,"\n");
	}
	
	if (0 != (level & DEBUG_SCANOBJ))
	{
		fprintf(stderr,"[SCANOBJ]: ");
		vfprintf(stderr,fmt,ap);
		fprintf(stderr,"\n");
	}

	if (0 != (level & DEBUG_PANEL))
	{
		fprintf(stderr,"[PANEL]: ");
		vfprintf(stderr,fmt,ap);
		fprintf(stderr,"\n");		
	}
	
	if (0 != (level & DEBUG_SANE))
	{
		fprintf(stderr,"[SANE]: ");
		vfprintf(stderr,fmt,ap);
		fprintf(stderr,"\n");		
	}

	if (0 != (level & DEBUG_LIBUSB))
	{
		fprintf(stderr,"[libusb]: ");
		vfprintf(stderr,fmt,ap);
		fprintf(stderr,"\n");
	}

  va_end(ap);
	
	return;
}
#endif /* End of file debug.h */
