/**********************************************************************
Copyright (C) 2005 Mustek Corporation, All rights reserved
    
Filename: spicall.h   [Abstract: ]

Author: Jack            Date: 2005/05/13
	
Function Description:
	Inform data and function of Spicall.c

[Operative Environment:]

[Reference Articles:]

Revision History:
*********************************************************************/
#ifndef _SpExport_2005_5_13_
#define _SpExport_2005_5_13_

#include "typedef.h"

///////////////////////////////////////////////////////
//
// const use in structures
//

//scan mode
typedef WORD SCANMODE, *LPSCANMODE;
#define SM_TEXT		0x00
#define SM_GRAY		0x01
#define SM_RGB24	0x02
#define SM_GRAY10	0x03
#define SM_RGB30	0x04
#define SM_GRAY12	0x05
#define SM_RGB36	0x06
#define SM_GRAY14	0x07
#define SM_RGB42	0x08
#define SM_GRAY16	0x09
#define SM_RGB48	0x0a

//pixel flavor
typedef BYTE PIXELFLAVOR, *LPPIXELFLAVOR;
#define PF_BlackIs0 0x00
#define PF_WhiteIs0 0x01

//scan source
typedef BYTE SCANSOURCE, *LPSCANSOURCE;
#define SS_Reflective	0x00
#define SS_Positive		0x01
#define SS_Negative		0x02
#define SS_ADF			0x03

//RGB order
typedef WORD RGBORDER, *LPRGBORDER;
#define RO_RGB 0x00
#define RO_BGR 0x01

///////////////////////////////////////////////////////
//
// structures use in parameters of export function
//

typedef struct tagGAMMAINFO {
	SCANMODE	smScanMode;
	WORD		wInputGammaBits;
	WORD		wOutputGammaBits;
} GAMMAINFO, *LPGAMMAINFO;

typedef struct tagGETPARAMETERS {
	WORD	wSourceXDPI;
	WORD	wSourceYDPI;
	DWORD	dwLineByteWidth;
	DWORD	dwLength;
} GETPARAMETERS, *LPGETPARAMETERS;

typedef struct tagFRAME {
	WORD x1;
	WORD y1;
	WORD x2;
	WORD y2;
} FRAME, *LPFRAME;

typedef struct tagSETPARAMETERS {
	FRAME		fmArea;
	WORD		wTargetDPI;
	SCANMODE	smScanMode;
	WORD		wLinearThreshold;		//threshold for Line art mode
	PIXELFLAVOR pfPixelFlavor;
	SCANSOURCE	ssScanSource;
	LPWORD		pGammaTable;
} SETPARAMETERS, *LPSETPARAMETERS;

typedef struct tagIMAGEROWS {
	RGBORDER	roRgbOrder;
	WORD		wWantedLineNum;
	WORD		wXferedLineNum;
	LPBYTE		pBuffer;
} IMAGEROWS, *LPIMAGEROWS;

///////////////////////////////////////////////////////
//
// export function in spicall module
//

BOOL _Open();
BOOL _Close();
BOOL GetDeviceStatus();
BOOL PowerControl(BOOL isLampOn, BOOL isTaLampOn);
BOOL CarriageHome();
BOOL GetGammaInfo(LPGAMMAINFO pGamaInfo);
BOOL SetParameters (LPSETPARAMETERS pSetParameters);
BOOL GetParameters(LPGETPARAMETERS pGetParameters);
BOOL StartScan();
BOOL ReadScannedData(LPIMAGEROWS pImageRows);
BOOL StopScan();
BOOL GetKeyStatus(BYTE* pKey);
BOOL IsTAConnected();

///////////////////////////////////////////////////////

#endif /* End of file spicall.h */

