/**********************************************************************
Copyright (C) 2005 Mustek Corporation, All rights reserved
    
Filename: ScannerDefine.h   [Abstract: ]

Author: Jack            Date: 2005/05/13
	
Function Description:
	Define the information for scanner

[Operative Environment:]

[Reference Articles:]

Revision History:
*********************************************************************/
#ifndef _SCANNER_DEFINE_2005_5_13_
#define _SCANNER_DEFINE_2005_5_13_

////////////////////////////////////////////////////////////
//Macro define
////////////////////////////////////////////////////////////
#define R_GAIN							0
#define G_GAIN                          0
#define B_GAIN                          0
#define R_OFFSET                        0
#define G_OFFSET                        0
#define B_OFFSET                        0
#define R_DIRECTION                     0
#define G_DIRECTION                     0
#define B_DIRECTION                     0

// use for adjust AD's offset

// for Reflective 
#define REFL_DARK_MAX_LEVEL             20
#define REFL_DARK_MIN_LEVEL             10 
#define REFL_WHITE_MAX_LEVEL			220
#define REFL_WHITE_MIN_LEVEL			210
#define REFL_MAX_LEVEL_RANGE            210
#define REFL_MIN_LEVEL_RANGE            190

//for Transparent
#define TRAN_DARK_MAX_LEVEL             20
#define TRAN_DARK_MIN_LEVEL             10 
#define TRAN_WHITE_MAX_LEVEL            220
#define TRAN_WHITE_MIN_LEVEL            210
#define TRAN_MAX_LEVEL_RANGE            210
#define TRAN_MIN_LEVEL_RANGE            190

/*
#define CALIBRATION_PIXEL_WIDTH			22528 //22016 //21504   //22528 
#define CALIBRATION_900_PIXEL_WIDTH	    23040 //21504   //22528 
#define CALIBRATION_450_PIXEL_WIDTH	    23040 //21504   //22528 
#define CALIBRATION_225_PIXEL_WIDTH	    25088 //21504   //22528 
#define CALIBRATION_112_PIXEL_WIDTH	    25088 //21504   //22528 
#define CALIBRATION_72_PIXEL_WIDTH	    26112 //21504   //22528 
#define CALIBRATION_56_PIXEL_WIDTH	    25088 //21504   //22528 
*/

// in 600 dpi
#define FIND_LEFT_TOP_WIDTH_IN_DIP          512
#define FIND_LEFT_TOP_HEIGHT_IN_DIP         180
#define FIND_LEFT_TOP_CALIBRATE_RESOLUTION  600

#define TA_FIND_LEFT_TOP_WIDTH_IN_DIP       2668
#define TA_FIND_LEFT_TOP_HEIGHT_IN_DIP      300

#define TA_MOTOR_BACK_STEP_AFTER_FIND_BOUNDARY             150
#define TA_MOTOR_FORWARD_STEP_AFTER_READ_WHITE_DATA        1100 

//must be 8x
#define LINE_CALIBRATION__16BITS_HEIGHT				40

// the length from block bar to start Calibration position
#define BEFORE_SCANNING_MOTOR_FORWARD_PIXEL 40

#define PRE_MOVE_MOTOR_LENGTH_IN_DPI    1450

// if the motor is 1/8 step, setup MOTOR_STEP_MULTI as 8
// if the motor is 1/4 step, setup MOTOR_STEP_MULTI as 4
// if the motor is full step, setup MOTOR_STEP_MULTI as 1
//#define MOTOR_EIGHTH_STEP
#ifdef MOTOR_EIGHTH_STEP
#define MOTOR_STEP_MULTI                8
#define GPIO_95_Config                  0x68
#else
#define MOTOR_STEP_MULTI                4
#define GPIO_95_Config                  0x60
#endif

#define TRAN_START_POS					4550

// in 300dpi
#define MAX_SCANNING_WIDTH               2550		//just for A4	
#define MAX_SCANNING_HEIGHT              3540       //just for A4

#define INIFILENAME						"msam.ini"

//enable gamma
#define ENABLE_GAMMA

//save debug image
//#define DEBUG_SAVE_IMAGE

//////////////////////////////////////////////////////////////////////
//type define
/////////////////////////////////////////////////////////////////////

typedef unsigned char SCANTYPE;
#define ST_Reflective	0x00
#define ST_Transparent	0x01

typedef enum tagCOLORMODE {
	CM_RGB48  = 0,
	CM_RGB42  = 1,
	CM_RGB36  = 2,
	CM_RGB30  = 3,
	CM_RGB24  = 4,
	CM_GRAY16 = 5,
	CM_GRAY14 = 6,
	CM_GRAY12 = 7,
	CM_GRAY10 = 8,
	CM_GRAY8  = 9,
	CM_TEXT   = 10,
	CM_RGB48ext = 11,
	CM_RGB42ext = 12,
	CM_RGB36ext = 13,
	CM_RGB30ext = 14,
	CM_RGB24ext = 15,
	CM_GRAY16ext = 16,
	CM_GRAY14ext = 17,
	CM_GRAY12ext = 18,
	CM_GRAY10ext = 19,
	CM_GRAY8ext  = 20,
	CM_TEXText   = 21
} COLORMODE, *PCOLORMODE;

typedef struct tagTARGETIMAGE {
	BOOL isOptimalSpeed;
	COLORMODE cmColorMode;
	WORD wDpi;
	WORD wX;
	WORD wY;
	WORD wWidth;
	WORD wHeight;
    BYTE bScanSource;
} TARGETIMAGE, *PTARGETIMAGE;

typedef struct tagSUGGESTSETTING {
	COLORMODE cmScanMode;
	WORD wXDpi;
	WORD wYDpi;
	WORD wX;
	WORD wY;
	WORD wWidth;
	WORD wHeight;
	DWORD dwBytesPerRow;
} SUGGESTSETTING, *PSUGGESTSETTING;

#endif /* end of the file ScannerDefine.h */
